{
  "openapi": "3.0.1",
  "info": {
    "title": "HTTP Request Builder",
    "description": "Build requests for public HTTP or HTTPS endpoints with methods, headers, query parameters, bodies, and expected status codes. Paste cURL commands or submit a batch, then get one result row per request with the status, final URL, response content, timing, and outcome.",
    "version": "0.0",
    "x-build-id": "CU1eEr7JvHz62gLie"
  },
  "servers": [
    {
      "url": "https://api.apify.com/v2"
    }
  ],
  "paths": {
    "/acts/maximedupre~http-request-builder/run-sync-get-dataset-items": {
      "post": {
        "operationId": "run-sync-get-dataset-items-maximedupre-http-request-builder",
        "x-openai-isConsequential": false,
        "summary": "Executes an Actor, waits for its completion, and returns Actor's dataset items in response.",
        "tags": [
          "Run Actor"
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/inputSchema"
              }
            }
          }
        },
        "parameters": [
          {
            "name": "token",
            "in": "query",
            "required": true,
            "schema": {
              "type": "string"
            },
            "description": "Enter your Apify token here"
          }
        ],
        "responses": {
          "200": {
            "description": "OK"
          }
        }
      }
    },
    "/acts/maximedupre~http-request-builder/runs": {
      "post": {
        "operationId": "runs-sync-maximedupre-http-request-builder",
        "x-openai-isConsequential": false,
        "summary": "Executes an Actor and returns information about the initiated run in response.",
        "tags": [
          "Run Actor"
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/inputSchema"
              }
            }
          }
        },
        "parameters": [
          {
            "name": "token",
            "in": "query",
            "required": true,
            "schema": {
              "type": "string"
            },
            "description": "Enter your Apify token here"
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/runsResponseSchema"
                }
              }
            }
          }
        }
      }
    },
    "/acts/maximedupre~http-request-builder/run-sync": {
      "post": {
        "operationId": "run-sync-maximedupre-http-request-builder",
        "x-openai-isConsequential": false,
        "summary": "Executes an Actor, waits for completion, and returns the OUTPUT from Key-value store in response.",
        "tags": [
          "Run Actor"
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/inputSchema"
              }
            }
          }
        },
        "parameters": [
          {
            "name": "token",
            "in": "query",
            "required": true,
            "schema": {
              "type": "string"
            },
            "description": "Enter your Apify token here"
          }
        ],
        "responses": {
          "200": {
            "description": "OK"
          }
        }
      }
    }
  },
  "components": {
    "schemas": {
      "inputSchema": {
        "type": "object",
        "required": [
          "requestInputType"
        ],
        "properties": {
          "requestInputType": {
            "title": "Send requests by",
            "enum": [
              "requestDetails",
              "curlCommands"
            ],
            "type": "string",
            "description": "Choose one request form for this run. Use Request details for named fields or cURL commands to paste complete commands."
          },
          "requests": {
            "title": "HTTP requests",
            "minItems": 1,
            "maxItems": 1000,
            "type": "array",
            "description": "Add one or more HTTP or HTTPS requests. Each request can include an ID, method, URL, headers, query parameters, body, and expected status codes.",
            "items": {
              "type": "object",
              "properties": {
                "id": {
                  "title": "Request ID",
                  "type": "string",
                  "description": "Optional ID to return with this request's result so you can match the result to your input.",
                  "minLength": 1
                },
                "method": {
                  "title": "Method",
                  "type": "string",
                  "description": "HTTP method for this request. GET is used when you leave this field empty.",
                  "editor": "select",
                  "enumSuggestedValues": [
                    "GET",
                    "POST",
                    "PUT",
                    "PATCH",
                    "DELETE",
                    "HEAD",
                    "OPTIONS"
                  ],
                  "default": "GET"
                },
                "url": {
                  "title": "URL",
                  "type": "string",
                  "description": "Public HTTP or HTTPS URL to request.",
                  "pattern": "^https?://[^\\s]+$"
                },
                "headers": {
                  "title": "Headers",
                  "type": "object",
                  "description": "Optional JSON object with header names and text values. Example: {\"Accept\":\"application/json\"}.",
                  "editor": "json",
                  "additionalProperties": true
                },
                "queryParameters": {
                  "title": "Query parameters",
                  "type": "object",
                  "description": "Optional JSON object with query names and text values. Example: {\"page\":\"2\",\"tag\":\"news\"}.",
                  "editor": "json",
                  "additionalProperties": true
                },
                "body": {
                  "title": "Body",
                  "type": "string",
                  "description": "Optional request body text. For JSON, enter JSON text such as {\"name\":\"Ada\"}.",
                  "editor": "textarea"
                },
                "expectedStatusCodes": {
                  "title": "Expected status codes",
                  "type": "array",
                  "description": "Optional list of HTTP status codes that this request should return. Leave it empty when any response status should be reported without this check.",
                  "items": {
                    "type": "integer",
                    "minimum": 100,
                    "maximum": 599
                  }
                }
              },
              "required": [
                "url"
              ]
            }
          },
          "curlCommands": {
            "title": "cURL commands",
            "minItems": 1,
            "maxItems": 1000,
            "type": "array",
            "description": "Add one cURL command for each request. Include the method, URL, headers, query parameters, and body in each command when needed.",
            "items": {
              "type": "object",
              "properties": {
                "id": {
                  "title": "Request ID",
                  "type": "string",
                  "description": "Optional ID to return with this request's result so you can match the result to your input.",
                  "minLength": 1
                },
                "command": {
                  "title": "cURL command",
                  "type": "string",
                  "description": "A complete cURL command for one HTTP or HTTPS request.",
                  "editor": "textarea",
                  "minLength": 1,
                  "pattern": "^\\s*curl(?:\\s|$)"
                }
              },
              "required": [
                "command"
              ]
            }
          }
        }
      },
      "runsResponseSchema": {
        "type": "object",
        "properties": {
          "data": {
            "type": "object",
            "properties": {
              "id": {
                "type": "string"
              },
              "actId": {
                "type": "string"
              },
              "userId": {
                "type": "string"
              },
              "startedAt": {
                "type": "string",
                "format": "date-time",
                "example": "2025-01-08T00:00:00.000Z"
              },
              "finishedAt": {
                "type": "string",
                "format": "date-time",
                "example": "2025-01-08T00:00:00.000Z"
              },
              "status": {
                "type": "string",
                "example": "READY"
              },
              "meta": {
                "type": "object",
                "properties": {
                  "origin": {
                    "type": "string",
                    "example": "API"
                  },
                  "userAgent": {
                    "type": "string"
                  }
                }
              },
              "stats": {
                "type": "object",
                "properties": {
                  "inputBodyLen": {
                    "type": "integer",
                    "example": 2000
                  },
                  "rebootCount": {
                    "type": "integer",
                    "example": 0
                  },
                  "restartCount": {
                    "type": "integer",
                    "example": 0
                  },
                  "resurrectCount": {
                    "type": "integer",
                    "example": 0
                  },
                  "computeUnits": {
                    "type": "integer",
                    "example": 0
                  }
                }
              },
              "options": {
                "type": "object",
                "properties": {
                  "build": {
                    "type": "string",
                    "example": "latest"
                  },
                  "timeoutSecs": {
                    "type": "integer",
                    "example": 300
                  },
                  "memoryMbytes": {
                    "type": "integer",
                    "example": 1024
                  },
                  "diskMbytes": {
                    "type": "integer",
                    "example": 2048
                  }
                }
              },
              "buildId": {
                "type": "string"
              },
              "defaultKeyValueStoreId": {
                "type": "string"
              },
              "defaultDatasetId": {
                "type": "string"
              },
              "defaultRequestQueueId": {
                "type": "string"
              },
              "buildNumber": {
                "type": "string",
                "example": "1.0.0"
              },
              "containerUrl": {
                "type": "string"
              },
              "usage": {
                "type": "object",
                "properties": {
                  "ACTOR_COMPUTE_UNITS": {
                    "type": "integer",
                    "example": 0
                  },
                  "DATASET_READS": {
                    "type": "integer",
                    "example": 0
                  },
                  "DATASET_WRITES": {
                    "type": "integer",
                    "example": 0
                  },
                  "KEY_VALUE_STORE_READS": {
                    "type": "integer",
                    "example": 0
                  },
                  "KEY_VALUE_STORE_WRITES": {
                    "type": "integer",
                    "example": 1
                  },
                  "KEY_VALUE_STORE_LISTS": {
                    "type": "integer",
                    "example": 0
                  },
                  "REQUEST_QUEUE_READS": {
                    "type": "integer",
                    "example": 0
                  },
                  "REQUEST_QUEUE_WRITES": {
                    "type": "integer",
                    "example": 0
                  },
                  "DATA_TRANSFER_INTERNAL_GBYTES": {
                    "type": "integer",
                    "example": 0
                  },
                  "DATA_TRANSFER_EXTERNAL_GBYTES": {
                    "type": "integer",
                    "example": 0
                  },
                  "PROXY_RESIDENTIAL_TRANSFER_GBYTES": {
                    "type": "integer",
                    "example": 0
                  },
                  "PROXY_SERPS": {
                    "type": "integer",
                    "example": 0
                  },
                  "PROXY_UNBLOCKER_UNITS": {
                    "type": "integer",
                    "example": 0
                  }
                }
              },
              "usageTotalUsd": {
                "type": "number",
                "example": 0.00005
              },
              "usageUsd": {
                "type": "object",
                "properties": {
                  "ACTOR_COMPUTE_UNITS": {
                    "type": "integer",
                    "example": 0
                  },
                  "DATASET_READS": {
                    "type": "integer",
                    "example": 0
                  },
                  "DATASET_WRITES": {
                    "type": "integer",
                    "example": 0
                  },
                  "KEY_VALUE_STORE_READS": {
                    "type": "integer",
                    "example": 0
                  },
                  "KEY_VALUE_STORE_WRITES": {
                    "type": "number",
                    "example": 0.00005
                  },
                  "KEY_VALUE_STORE_LISTS": {
                    "type": "integer",
                    "example": 0
                  },
                  "REQUEST_QUEUE_READS": {
                    "type": "integer",
                    "example": 0
                  },
                  "REQUEST_QUEUE_WRITES": {
                    "type": "integer",
                    "example": 0
                  },
                  "DATA_TRANSFER_INTERNAL_GBYTES": {
                    "type": "integer",
                    "example": 0
                  },
                  "DATA_TRANSFER_EXTERNAL_GBYTES": {
                    "type": "integer",
                    "example": 0
                  },
                  "PROXY_RESIDENTIAL_TRANSFER_GBYTES": {
                    "type": "integer",
                    "example": 0
                  },
                  "PROXY_SERPS": {
                    "type": "integer",
                    "example": 0
                  },
                  "PROXY_UNBLOCKER_UNITS": {
                    "type": "integer",
                    "example": 0
                  }
                }
              }
            }
          }
        }
      }
    }
  }
}